## kf5-messagelib 22.12.3

=== CMakeLists.txt ===
# SPDX-License-Identifier: CC0-1.0
# SPDX-FileCopyrightText: none
cmake_minimum_required(VERSION 3.16 FATAL_ERROR)
set(PIM_VERSION "5.22.3")


project(Messagelib VERSION ${PIM_VERSION})

option(KDEPIM_ENTERPRISE_BUILD "Enable features specific to the enterprise branch, which are normally disabled. Also, it disables many components not needed for Kontact such as the Kolab client." FALSE)

option(MESSAGEVIEWER_EXPERIMENTAL_CONVERSATIONVIEW "Experimental conversationview (in progress)" FALSE)

set(KF5_MIN_VERSION "5.99.0")


set(MESSAGELIB_LIB_VERSION ${PIM_VERSION})
set(AKONADIMIME_LIB_VERSION "5.22.3")

set(QT_REQUIRED_VERSION "5.15.2")
if (QT_MAJOR_VERSION STREQUAL "6")
    set(QT_REQUIRED_VERSION "6.4.0")
endif()
set(AKONADICONTACT_LIB_VERSION "5.22.3")
set(AKONADI_VERSION "5.22.3")
set(GRANTLEETHEME_LIB_VERSION "5.22.3")
set(GRAVATAR_LIB_VERSION "5.22.3")
set(IDENTITYMANAGEMENT_LIB_VERSION "5.22.3")
set(KMAILTRANSPORT_LIB_VERSION "5.22.3")
set(KMBOX_LIB_VERSION "5.22.3")
set(KMIME_LIB_VERSION "5.22.3")
set(KPIMTEXTEDIT_LIB_VERSION "5.22.3")
set(LIBKDEPIM_LIB_VERSION "5.22.3")
set(LIBKLEO_LIB_VERSION "5.22.3")
set(PIMCOMMON_LIB_VERSION "5.22.3")
set(GPGME_LIB_VERSION "1.16.0")
set(AKONADI_SEARCH_VERSION "5.22.3")

set(ECM_VERSION ${KF5_MIN_VERSION})

find_package(ECM ${ECM_VERSION} CONFIG REQUIRED)
set(CMAKE_MODULE_PATH ${Messagelib_SOURCE_DIR}/cmake/modules ${ECM_MODULE_PATH})

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)

include(GenerateExportHeader)
include(ECMSetupVersion)
include(ECMGenerateHeaders)
include(ECMGeneratePriFile)

include(FeatureSummary)
include(KDEGitCommitHooks)
include(KDEClangFormat)
file(GLOB_RECURSE ALL_CLANG_FORMAT_SOURCE_FILES *.cpp *.h *.c)
kde_clang_format(${ALL_CLANG_FORMAT_SOURCE_FILES})

include(ECMQtDeclareLoggingCategory)
include(ECMDeprecationSettings)
include(ECMAddTests)
include(ECMAddQch)


option(BUILD_QCH "Build API documentation in QCH format (for e.g. Qt Assistant, Qt Creator & KDevelop)" OFF)
add_feature_info(QCH ${BUILD_QCH} "API documentation in QCH format (for e.g. Qt Assistant, Qt Creator & KDevelop)")


find_package(Qt${QT_MAJOR_VERSION} ${QT_REQUIRED_VERSION} CONFIG REQUIRED Gui Test)
find_package(Qt${QT_MAJOR_VERSION} ${QT_REQUIRED_VERSION} CONFIG REQUIRED Widgets Network PrintSupport WebEngineWidgets)
if (QT_MAJOR_VERSION STREQUAL "6")
    find_package(Qt6Core5Compat)
endif()

find_package(KF5CoreAddons ${KF5_MIN_VERSION} CONFIG REQUIRED)
find_package(KF5Codecs ${KF5_MIN_VERSION} CONFIG REQUIRED)
find_package(KF5I18n ${KF5_MIN_VERSION} CONFIG REQUIRED)
find_package(KF5Mime ${KMIME_LIB_VERSION} CONFIG REQUIRED)
find_package(KF5NewStuff ${KF5_MIN_VERSION} CONFIG REQUIRED)
if (QT_MAJOR_VERSION STREQUAL "6")
    find_package(QGpgmeQt6 ${GPGME_REQUIRED_VERSION} CONFIG REQUIRED)
else()
    find_package(QGpgme ${GPGME_REQUIRED_VERSION} CONFIG REQUIRED)
endif()
find_package(KF5Archive ${KF5_MIN_VERSION} CONFIG REQUIRED)
find_package(KF5Completion ${KF5_MIN_VERSION} CONFIG REQUIRED)
find_package(KF5Config ${KF5_MIN_VERSION} CONFIG REQUIRED)
find_package(KF5ConfigWidgets ${KF5_MIN_VERSION} CONFIG REQUIRED)
find_package(KF5IconThemes ${KF5_MIN_VERSION} CONFIG REQUIRED)
find_package(KF5ItemViews ${KF5_MIN_VERSION} CONFIG REQUIRED)
find_package(KF5JobWidgets ${KF5_MIN_VERSION} CONFIG REQUIRED)
find_package(KF5KIO ${KF5_MIN_VERSION} CONFIG REQUIRED)
find_package(KF5Service ${KF5_MIN_VERSION} CONFIG REQUIRED)
find_package(KF5Sonnet ${KF5_MIN_VERSION} CONFIG REQUIRED)
find_package(KF5TextWidgets ${KF5_MIN_VERSION} CONFIG REQUIRED)
find_package(KF5WidgetsAddons ${KF5_MIN_VERSION} CONFIG REQUIRED)
find_package(KF5XmlGui ${KF5_MIN_VERSION} CONFIG REQUIRED)
find_package(KF5SyntaxHighlighting ${KF5_MIN_VERSION} CONFIG REQUIRED)
find_package(KF5DBusAddons ${KF5_MIN_VERSION} CONFIG REQUIRED)
find_package(KF5GuiAddons ${KF5_MIN_VERSION} CONFIG REQUIRED)
find_package(KF5Notifications ${KF5_MIN_VERSION} CONFIG REQUIRED)

if (QT_MAJOR_VERSION STREQUAL "5")
    find_package(Grantlee5 "5.2" CONFIG REQUIRED)
    set(TEMPLATES_LIB Grantlee5::Templates)
else()
    find_package(KF6TextTemplate ${KF5_MIN_VERSION} CONFIG REQUIRED)
    set(TEMPLATES_LIB KF6TextTemplate::Templates)
endif()

find_package(KF5Akonadi ${AKONADI_VERSION} CONFIG REQUIRED)
find_package(KF5AkonadiMime ${AKONADIMIME_LIB_VERSION} CONFIG REQUIRED)
find_package(KF5Contacts ${KF5_MIN_VERSION} CONFIG REQUIRED)
find_package(KF5AkonadiContact ${AKONADICONTACT_LIB_VERSION} CONFIG REQUIRED)
find_package(KF5GrantleeTheme ${GRANTLEETHEME_LIB_VERSION} CONFIG REQUIRED)
find_package(KF5Gravatar ${GRAVATAR_LIB_VERSION} CONFIG REQUIRED)
find_package(KF5IdentityManagement ${IDENTITYMANAGEMENT_LIB_VERSION} CONFIG REQUIRED)
find_package(KF5Libkleo ${LIBKLEO_LIB_VERSION} CONFIG REQUIRED)
find_package(KF5MailTransportAkonadi ${KMAILTRANSPORT_LIB_VERSION} CONFIG REQUIRED)
find_package(KF5Mbox ${KMBOX_LIB_VERSION} CONFIG REQUIRED)
find_package(KF5PimCommonAkonadi ${PIMCOMMON_LIB_VERSION} CONFIG REQUIRED)
find_package(KF5PimCommonAutoCorrection ${PIMCOMMON_LIB_VERSION} CONFIG REQUIRED)
find_package(KF5PimTextEdit ${KPIMTEXTEDIT_LIB_VERSION} CONFIG REQUIRED)
find_package(KF5Libkdepim ${LIBKDEPIM_LIB_VERSION} CONFIG REQUIRED)

find_package(KF5AkonadiSearch ${AKONADI_SEARCH_VERSION} CONFIG REQUIRED)
set_package_properties(KF5AkonadiSearch PROPERTIES DESCRIPTION "The Akonadi Search libraries" URL "https://invent.kde.org/pim/akonadi-search" TYPE REQUIRED PURPOSE "Provides search capabilities in KMail and Akonadi")

ecm_set_disabled_deprecation_versions(QT 5.14.0 KF 5.99.0)

if(BUILD_TESTING)
    add_definitions(-DBUILD_TESTING)
endif()

option(USE_UNITY_CMAKE_SUPPORT "Use UNITY cmake support (speedup compile time)" OFF)

set(COMPILE_WITH_UNITY_CMAKE_SUPPORT OFF)
if (USE_UNITY_CMAKE_SUPPORT)
    set(COMPILE_WITH_UNITY_CMAKE_SUPPORT ON)
    add_definitions(-DCOMPILE_WITH_UNITY_CMAKE_SUPPORT)
endif()

add_subdirectory(mimetreeparser)
add_subdirectory(messageviewer)
add_subdirectory(templateparser)
add_subdirectory(messagecomposer)
add_subdirectory(messagecore)
add_subdirectory(messagelist)
add_subdirectory(webengineviewer)

ecm_qt_install_logging_categories(
    EXPORT MESSAGELIB
    FILE messagelib.categories
    DESTINATION ${KDE_INSTALL_LOGGINGCATEGORIESDIR}
    )

kde_configure_git_pre_commit_hook(CHECKS CLANG_FORMAT)
ki18n_install(po)
feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== mimetreeparser/CMakeLists.txt ===
# SPDX-License-Identifier: CC0-1.0
# SPDX-FileCopyrightText: none
ecm_setup_version(PROJECT VARIABLE_PREFIX MIMETREEPARSER
    VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/mimetreeparser_version.h"
    PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/KF5MimeTreeParserConfigVersion.cmake"
    SOVERSION 5
    )


########### Targets ###########

set(CMAKECONFIG_INSTALL_DIR "${KDE_INSTALL_CMAKEPACKAGEDIR}/KF5MimeTreeParser")

configure_package_config_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/KF5MimeTreeParserConfig.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/KF5MimeTreeParserConfig.cmake"
    INSTALL_DESTINATION  ${CMAKECONFIG_INSTALL_DIR}
    )

install(FILES
    "${CMAKE_CURRENT_BINARY_DIR}/KF5MimeTreeParserConfig.cmake"
    "${CMAKE_CURRENT_BINARY_DIR}/KF5MimeTreeParserConfigVersion.cmake"
    DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
    COMPONENT Devel
    )

install(EXPORT KF5MimeTreeParserTargets DESTINATION "${CMAKECONFIG_INSTALL_DIR}" FILE KF5MimeTreeParserTargets.cmake NAMESPACE KF5::)

install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/mimetreeparser_version.h
    DESTINATION ${KDE_INSTALL_INCLUDEDIR_KF}/MimeTreeParser COMPONENT Devel
    )

add_subdirectory(src)
if (BUILD_TESTING)
    add_subdirectory(autotests)
    add_subdirectory(src/temporaryfile/autotests)
endif()

=== messagecomposer/autotests/CMakeLists.txt ===
# SPDX-License-Identifier: CC0-1.0
# SPDX-FileCopyrightText: none
set(EXECUTABLE_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR})
add_definitions( -DMESSAGECORE_DATA_DIR="${CMAKE_SOURCE_DIR}/messagecore/autotests/data" )
add_definitions( -DMAIL_DATA_DIR="${CMAKE_CURRENT_SOURCE_DIR}/data" )
add_definitions( -DGNUPGHOME="${CMAKE_BINARY_DIR}/messagecore/autotests/gnupg_home")

include( ${CMAKE_SOURCE_DIR}/cmake/modules/kdepim_add_gpg_crypto_test.cmake )

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../src/part)

# Convenience macro to add messagecomposer unit tests.
macro( add_messagecomposer_test _source )
    get_filename_component( _name ${_source} NAME_WE )
    ecm_add_test(${ARGV}
        TEST_NAME ${_name}
        NAME_PREFIX "messagecomposer-"
        LINK_LIBRARIES
            KF5::I18n
            KF5::MailTransport
            KF5::Mime
            KF5::MessageComposer
            KF5::MessageViewer
            KF5::MessageCore
            KF5::TemplateParser
            KF5::PimTextEdit
            Qt::Test
            KF5::IdentityManagementWidgets
            KF5::Contacts
            KF5::AkonadiCore
            KF5::XmlGui
            KF5::Libkdepim
            KF5::IconThemes
            KF5::Completion
    )
endmacro()

macro( add_messagecomposer_cryptotest _source )
    set( _test cryptofunctions.cpp setupenv.cpp ${_source} )
    get_filename_component( _name ${_source} NAME_WE )
    add_executable( ${_name} ${_test}  ${_name}.h )
    target_link_libraries(
        ${_name}
        KF5::I18n
        KF5::Mime
        KF5::MessageComposer
        KF5::MessageViewer
        KF5::MessageCore
        KF5::Libkleo
        KF5::Libkdepim
        KF5::PimTextEdit
        KF5::AkonadiCore
        Qt::Test
        KF5::IconThemes
        KF5::Completion
        KF5::MailTransport
        KF5::Contacts
    )
    add_gpg_crypto_test(${_name} messagecomposer-${_name})
    set_tests_properties(messagecomposer-${_name} PROPERTIES
        ENVIRONMENT "LC_ALL=en_US.UTF-8"
    )
endmacro()


# Utility stuff.
add_messagecomposer_test( draftstatustest.cpp )
add_messagecomposer_test( utiltest.cpp )
add_messagecomposer_test( messagefactoryngtest.cpp setupenv.cpp)
add_messagecomposer_test( plugineditorcheckbeforesendparamstest.cpp )
add_messagecomposer_test( replystrategytest.cpp )

# Non-content jobs.
add_messagecomposer_test( skeletonmessagejobtest.cpp )

# Basic content jobs.
add_messagecomposer_test( singlepartjobtest.cpp )
add_messagecomposer_test( multipartjobtest.cpp )

# More complex content jobs.
add_messagecomposer_test( attachmentjobtest.cpp )
add_messagecomposer_test( maintextjobtest.cpp )

# Composer.
add_messagecomposer_test( composertest.cpp )
add_messagecomposer_cryptotest( cryptocomposertest.cpp )
add_messagecomposer_test( infoparttest.cpp )
add_messagecomposer_test( textparttest.cpp )
add_messagecomposer_test( globalparttest.cpp )
add_messagecomposer_cryptotest( composerviewbasetest.cpp )

add_messagecomposer_test( recipientseditortest.cpp )

# SendLater
add_messagecomposer_test( sendlaterdialogtest.cpp )
add_messagecomposer_test( sendlaterinfotest.cpp )

# Crypto
add_messagecomposer_cryptotest( autocryptheadersjobtest.cpp )
add_messagecomposer_cryptotest( signjobtest.cpp )
add_messagecomposer_cryptotest( encryptjobtest.cpp )
add_messagecomposer_cryptotest( signencrypttest.cpp )
add_messagecomposer_cryptotest( signandencrypttest.cpp )
add_messagecomposer_cryptotest( keyresolvertest.cpp )

ecm_add_test( nearexpirycheckertest.cpp setupenv.cpp
        TEST_NAME "nearexpirycheckertest"
        NAME_PREFIX "messagecomposer-"
        LINK_LIBRARIES
            KF5::MessageComposer
            Qt::Test
            KF5::Libkleo
    )

set(AKONADI_RUN_POSTGRES_ISOLATED_TESTS FALSE)
set(AKONADI_RUN_MYSQL_ISOLATED_TESTS FALSE)

ecm_add_test(followupreminderselectdatedialogtest.cpp
    NAME_PREFIX "messagecomposer-"
    LINK_LIBRARIES
        KF5::AkonadiCore
        KF5::AkonadiWidgets
        KF5::CalendarCore
        KF5::MessageComposer
        Qt::Test
)

ecm_add_test(attachmentvcardfromaddressbookjobtest.cpp
    NAME_PREFIX "messagecomposer-"
    LINK_LIBRARIES
        KF5::Contacts
        KF5::MessageComposer
        Qt::Test
)

=== messagelist/src/CMakeLists.txt ===
# SPDX-License-Identifier: CC0-1.0
# SPDX-FileCopyrightText: none

option(KDEPIM_FOLDEROPEN_PROFILE "Enable debug output for timing folder loading" FALSE)
configure_file(config-messagelist.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-messagelist.h)
add_library(KF5MessageList)
add_library(KF5::MessageList ALIAS KF5MessageList)

add_definitions(-DTRANSLATION_DOMAIN=\"libmessagelist\")

add_subdirectory(pics)
if(BUILD_TESTING)
	add_subdirectory(core/widgets/autotests)
endif()
target_sources(KF5MessageList PRIVATE
    core/aggregation.cpp
    core/delegate.cpp
    core/filter.cpp
    core/item.cpp
    core/groupheaderitem.cpp
    core/manager.cpp
    core/messageitem.cpp
    core/messageitemsetmanager.cpp
    core/model.cpp
    core/modelinvariantindex.cpp
    core/modelinvariantrowmapper.cpp
    core/optionset.cpp
    core/theme.cpp
    core/themedelegate.cpp
    core/threadingcache.cpp
    core/storagemodelbase.cpp
    core/sortorder.cpp
    core/view.cpp
    core/widgetbase.cpp
    core/filtersavedmanager.cpp
    core/widgets/quicksearchline.cpp
    core/widgets/quicksearchwarning.cpp
    core/widgets/searchlinestatus.cpp
    core/widgets/searchcollectionindexingwarning.cpp
    core/widgets/tablockedwarning.cpp
    core/widgets/filtersavedmenu.cpp
    core/widgets/configurefiltersdialog.cpp
    core/widgets/configurefilterswidget.cpp
    core/widgets/filternamedialog.cpp
    core/widgets/filternamewidget.cpp

    utils/aggregationcombobox.cpp
    utils/aggregationconfigbutton.cpp
    utils/aggregationeditor.cpp
    utils/comboboxutils.cpp
    utils/configureaggregationsdialog.cpp
    utils/configurethemesdialog.cpp
    utils/optionseteditor.cpp
    utils/themecombobox.cpp
    utils/themeconfigbutton.cpp
    utils/themeeditor.cpp

    pane.cpp
    storagemodel.cpp
    widget.cpp
    messagelistutil.cpp
    utils/aggregationconfigbutton.h
    utils/themecombobox_p.h
    utils/themeconfigbutton.h
    utils/configureaggregationsdialog_p.h
    utils/aggregationcombobox_p.h
    utils/themecombobox.h
    utils/configureaggregationsdialog.h
    utils/optionseteditor.h
    utils/configurethemesdialog.h
    utils/aggregationeditor.h
    utils/aggregationcombobox.h
    utils/comboboxutils.h
    utils/configurethemesdialog_p.h
    utils/themeeditor.h
    messagelist_private_export.h
    pane.h
    storagemodel.h
    widget.h
    messagelistutil.h
    messagelistutil_p.h
    core/groupheaderitem.h
    core/optionset.h
    core/item_p.h
    core/filtersavedmanager.h
    core/manager.h
    core/model.h
    core/messageitem_p.h
    core/storagemodelbase.h
    core/aggregation.h
    core/enums.h
    core/messageitemsetmanager.h
    core/modelinvariantrowmapper_p.h
    core/sortorder.h
    core/themedelegate.h
    core/widgetbase.h
    core/modelinvariantindex.h
    core/model_p.h
    core/view.h
    core/filter.h
    core/threadingcache.h
    core/theme.h
    core/widgets/tablockedwarning.h
    core/widgets/filtersavedmenu.h
    core/widgets/quicksearchwarning.h
    core/widgets/filternamewidget.h
    core/widgets/filternamedialog.h
    core/widgets/configurefiltersdialog.h
    core/widgets/quicksearchline.h
    core/widgets/searchlinestatus.h
    core/widgets/searchcollectionindexingwarning.h
    core/widgets/configurefilterswidget.h
    core/modelinvariantrowmapper.h
    core/messageitem.h
    core/modelinvariantindex_p.h
    core/delegate.h
    core/item.h

    )
ecm_qt_declare_logging_category(KF5MessageList HEADER messagelist_debug.h IDENTIFIER MESSAGELIST_LOG CATEGORY_NAME org.kde.pim.messagelist
        DESCRIPTION "messagelib (messagelist)"
        OLD_CATEGORY_NAMES log_messagelist
        EXPORT MESSAGELIB
    )

kconfig_add_kcfg_files(KF5MessageList
    core/messagelistsettings.kcfgc
    )

if (COMPILE_WITH_UNITY_CMAKE_SUPPORT)
    set_target_properties(KF5MessageList PROPERTIES UNITY_BUILD ON)
endif()

generate_export_header(KF5MessageList BASE_NAME messagelist)

target_include_directories(KF5MessageList INTERFACE "$<INSTALL_INTERFACE:${KDE_INSTALL_INCLUDEDIR_KF}/MessageList/>")

target_link_libraries(KF5MessageList
    PUBLIC
    KF5::AkonadiCore
    KF5::AkonadiMime
    KF5::Mime
    PRIVATE
    KF5::KIOCore
    KF5::MessageCore
    KF5::PimCommonAkonadi
    KF5::AkonadiSearchPIM
    KF5::XmlGui
    KF5::IconThemes
    KF5::Completion
    KF5::I18n
    KF5::TextWidgets
    )

set_target_properties(KF5MessageList PROPERTIES
    VERSION ${MESSAGELIST_VERSION}
    SOVERSION ${MESSAGELIST_SOVERSION}
    EXPORT_NAME MessageList
    )

install(TARGETS
    KF5MessageList
    EXPORT KF5MessageListTargets ${KF_INSTALL_TARGETS_DEFAULT_ARGS}
    )

ecm_generate_headers(MessageList_Camelcasecore_HEADERS
    HEADER_NAMES
    View
    Enums
    StorageModelBase
    WidgetBase
    REQUIRED_HEADERS MessageList_core_HEADERS
    RELATIVE core
    PREFIX MessageList

    )

ecm_generate_headers(MessageList_Camelcaseutil_HEADERS
    HEADER_NAMES
    AggregationComboBox
    ThemeComboBox
    AggregationConfigButton
    ThemeConfigButton
    REQUIRED_HEADERS MessageList_util_HEADERS
    RELATIVE utils
    PREFIX MessageList

    )

ecm_generate_headers(MessageList_Camelcasewidgets_HEADERS
    HEADER_NAMES
    QuickSearchLine
    REQUIRED_HEADERS MessageList_widgets_HEADERS
    RELATIVE core/widgets
    PREFIX MessageList

    )


ecm_generate_headers(MessageList_CamelCase_HEADERS
    HEADER_NAMES
    Pane
    StorageModel
    MessageListUtil
    REQUIRED_HEADERS MessageList_HEADERS
    PREFIX MessageList
    )

ecm_generate_pri_file(BASE_NAME MessageList
    LIB_NAME KF5MessageList
    DEPS "AkonadiCore AkonadiMime KMime" FILENAME_VAR PRI_FILENAME INCLUDE_INSTALL_DIR ${KDE_INSTALL_INCLUDEDIR_KF}/MessageList
    )


install(FILES
    ${MessageList_Camelcasewidgets_HEADERS}
    ${MessageList_CamelCase_HEADERS}
    ${MessageList_Camelcasecore_HEADERS}
    ${MessageList_Camelcaseutil_HEADERS}
    DESTINATION ${KDE_INSTALL_INCLUDEDIR_KF}/MessageList/MessageList
    COMPONENT Devel
    )

install(FILES
    ${MessageList_HEADERS}
    ${MessageList_widgets_HEADERS}
    ${CMAKE_CURRENT_BINARY_DIR}/messagelist_export.h
    ${CMAKE_CURRENT_BINARY_DIR}/messagelistsettings.h
    ${MessageList_core_HEADERS}
    ${MessageList_util_HEADERS}
    DESTINATION ${KDE_INSTALL_INCLUDEDIR_KF}/MessageList/messagelist
    COMPONENT Devel
    )
install(FILES
    ${PRI_FILENAME}
    DESTINATION ${ECM_MKSPECS_INSTALL_DIR})

if (BUILD_QCH)
    ecm_add_qch(
        KF5MessageList_QCH
        NAME KF5MessageList
        BASE_NAME KF5MessageList
        VERSION ${PIM_VERSION}
        ORG_DOMAIN org.kde
        SOURCES # using only public headers, to cover only public API
        ${MessageList_HEADERS}
        ${MessageList_widgets_HEADERS}
        ${MessageList_core_HEADERS}
        ${MessageList_util_HEADERS}
        LINK_QCHS
            Qt5Core_QCH
            Qt5Gui_QCH
            Qt5Widgets_QCH
        INCLUDE_DIRS
            ${CMAKE_CURRENT_BINARY_DIR}
        BLANK_MACROS
            MESSAGELIST_EXPORT
        TAGFILE_INSTALL_DESTINATION ${KDE_INSTALL_QTQCHDIR}
        QCH_INSTALL_DESTINATION ${KDE_INSTALL_QTQCHDIR}
        COMPONENT Devel
    )

    ecm_install_qch_export(
        TARGETS KF5MessageList_QCH
        FILE KF5MessageListQchTargets.cmake
        DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
        COMPONENT Devel
    )
    set(PACKAGE_INCLUDE_QCHTARGETS "include(\"\${CMAKE_CURRENT_LIST_DIR}/KF5MessageListQchTargets.cmake\")")
endif()

=== messageviewer/src/CMakeLists.txt ===
# SPDX-License-Identifier: CC0-1.0
# SPDX-FileCopyrightText: none

add_definitions(-DTRANSLATION_DOMAIN=\"libmessageviewer\")

add_subdirectory(messagepartthemes/grantlee)

# KCFG files:
# The main messageviewer.kcfg is configured by CMake and put in the build directory.

if(KDEPIM_ENTERPRISE_BUILD)
    set(LEGACY_MANGLE_FROM_TO_HEADERS true)
    set(LEGACY_BODY_INVITES true)
    set(EXCHANGE_COMPATIBLE_INVITATIONS true)
else()
    set(LEGACY_MANGLE_FROM_TO_HEADERS false)
    set(LEGACY_BODY_INVITES false)
    set(EXCHANGE_COMPATIBLE_INVITATIONS false)
endif()

configure_file(settings/messageviewer.kcfg.cmake ${CMAKE_CURRENT_BINARY_DIR}/messageviewer.kcfg)
include(CheckIncludeFiles)
find_package(Inotify)
set_package_properties(Inotify PROPERTIES
                       PURPOSE "Filesystem alteration notifications using inotify")
if(Inotify_FOUND)
    set(HAVE_SYS_INOTIFY_H 1)
else()
    set(HAVE_SYS_INOTIFY_H 0)
endif()

find_package(Qca-qt${QT_MAJOR_VERSION} 2.2.0 CONFIG REQUIRED)
set_package_properties(Qca-qt${QT_MAJOR_VERSION} PROPERTIES DESCRIPTION "Qt Cryptographic Architecture"
                   URL "https://invent.kde.org/libraries/qca" TYPE REQUIRED
                   PURPOSE "Needed for dkim support.")


configure_file(config-messageviewer.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-messageviewer.h)

# target_include_directories does not handle empty include paths
include_directories(${GPGME_INCLUDES})

add_library(KF5MessageViewer)
add_library(KF5::MessageViewer ALIAS KF5MessageViewer)


if(BUILD_TESTING)
    add_subdirectory(header/autotests)
    add_subdirectory(scamdetection/autotests)
    add_subdirectory(scamdetection/tests)
    add_subdirectory(viewerplugins/tests/)
    add_subdirectory(htmlwriter/autotests)
    add_subdirectory(viewer/webengine/tests)
    add_subdirectory(messagepartthemes/default/autotests)
    add_subdirectory(widgets/autotests/)
    add_subdirectory(utils/autotests)
    add_subdirectory(viewer/renderer/autotests)
    add_subdirectory(remote-content/autotests)
    add_subdirectory(openurlwith/autotests)
    add_subdirectory(mdn/autotests)
endif()
add_subdirectory(pics)
add_subdirectory(about)
add_subdirectory(messageviewerheaderplugins)

if (BUILD_TESTING)
    add_subdirectory(dkim-verify/autotests)
    add_subdirectory(dkim-verify/tests)
endif()
target_sources(KF5MessageViewer PRIVATE
    dkim-verify/dkiminfo.cpp
    dkim-verify/dkimmanagerkey.cpp
    dkim-verify/dkimmanagerkeywidget.cpp
    dkim-verify/dkimmanagerkeydialog.cpp
    dkim-verify/dkimdownloadkeyjob.cpp
    dkim-verify/dkimchecksignaturejob.cpp
    dkim-verify/dkimcheckauthenticationstatusjob.cpp
    dkim-verify/dkimauthenticationstatusinfo.cpp
    dkim-verify/dkimutil.cpp
    dkim-verify/dkimkeyrecord.cpp
    dkim-verify/dkimmanager.cpp
    dkim-verify/dkimresultattribute.cpp
    dkim-verify/dkimwidgetinfo.cpp
    dkim-verify/dkimstoreresultjob.cpp
    dkim-verify/dkimheaderparser.cpp
    dkim-verify/dkimcheckpolicy.cpp
    dkim-verify/dmarcrecordjob.cpp
    dkim-verify/dmarcinfo.cpp
    dkim-verify/dmarcpolicyjob.cpp
    dkim-verify/dkimcheckpolicyjob.cpp
    dkim-verify/dkimrule.cpp
    dkim-verify/dkimmanagerrules.cpp
    dkim-verify/dkimgeneraterulejob.cpp
    dkim-verify/dkimauthenticationstatusinfoutil.cpp
    dkim-verify/dkimcheckfulljob.cpp
    dkim-verify/dkimauthenticationstatusinfoconverter.cpp
    dkim-verify/dkimmanagerauthenticationserver.cpp
    dkim-verify/dkimviewermenu.cpp
    dkim-verify/dkimmanagerulescombobox.cpp
    dkim-verify/dkimmanagerulesdialog.cpp
    dkim-verify/dkimmanageruleswidget.cpp
    dkim-verify/dkimruledialog.cpp
    dkim-verify/dkimrulewidget.cpp
    dkim-verify/dmarcmanager.cpp
)


if(DEBUG_SIGNATURE)
    add_definitions(-DDEBUG_SIGNATURE)
endif()
if (MESSAGEVIEWER_EXPERIMENTAL_CONVERSATIONVIEW)
    target_sources(KF5MessageViewer PRIVATE
        conversationview/conversationviewwidget.cpp
        conversationview/conversationviewwidget.h
        )
    if (BUILD_TESTING)
        add_subdirectory(conversationview/autotests)
        add_subdirectory(conversationview/tests)
    endif()
endif()
target_sources(KF5MessageViewer PRIVATE
    viewer/renderer/messageviewerrenderer.cpp
    viewer/webengine/mailwebengineview.cpp
    viewer/webengine/mailwebenginepage.cpp
    viewer/webengine/loadexternalreferencesurlinterceptor/loadexternalreferencesurlinterceptor.cpp
    viewer/webengine/cidreferencesurlinterceptor/cidreferencesurlinterceptor.cpp
    viewer/webengine/cidschemehandler/cidschemehandler.cpp
    viewer/attachmentstrategy.cpp
    viewer/csshelper.cpp
    viewer/csshelperbase.cpp
    viewer/editorwatcher.cpp
    viewer/objecttreeemptysource.cpp
    viewer/objecttreeviewersource.cpp
    viewer/viewer.cpp
    viewer/viewer_p.cpp
    viewer/messagedisplayformatattribute.cpp
    viewer/urlhandlermanager.cpp
    viewer/mimeparttree/mimeparttreeview.cpp
    viewer/mimeparttree/mimetreemodel.cpp
    viewer/viewerpurposemenuwidget.cpp
    viewer/messagewidgetarea.cpp
    widgets/attachmentdialog.cpp
    widgets/configurewidget.cpp
    widgets/printingsettings.cpp
    widgets/htmlstatusbar.cpp
    widgets/vcardviewer.cpp
    widgets/invitationsettings.cpp
    widgets/opensavedfilefolderwidget.cpp
    widgets/mailsourceviewtextbrowserwidget.cpp
    widgets/shownextmessagewidget.cpp
    widgets/mailsourcewebengineviewer.cpp
    header/contactdisplaymessagememento.cpp
    header/headerstrategy.cpp
    header/richheaderstrategy.cpp
    header/headerstyle.cpp
    header/grantleeheaderstyle.cpp
    header/plainheaderstyle.cpp
    header/headerstyle_util.cpp
    header/grantleeheaderformatter.cpp
    header/grantleeheaderteststyle.cpp
    header/kxface.cpp
    header/headerstyleplugin.cpp
    header/headerstylepluginmanager.cpp
    header/headerstyleinterface.cpp
    header/headerstylemenumanager.cpp
    scamdetection/scamdetectionwarningwidget.cpp
    scamdetection/scamdetectiondetailsdialog.cpp
    scamdetection/scamattribute.cpp
    scamdetection/scamcheckshorturl.cpp
    scamdetection/scamexpandurljob.cpp
    scamdetection/scamcheckshorturlmanager.cpp
    scamdetection/scamdetectionwebengine.cpp
    scamdetection/scamdetectionwhitelistsettingsmanager.cpp
    scamdetection/scamdetectioninfo.cpp
    findbar/findbarsourceview.cpp
    utils/iconnamecache.cpp
    utils/markmessagereadhandler.cpp
    utils/messageviewerutil.cpp
    utils/mimetype.cpp
    htmlwriter/webengineparthtmlwriter.cpp
    htmlwriter/webengineembedpart.cpp
    htmlwriter/bufferedhtmlwriter.cpp
    htmlwriter/filehtmlwriter.cpp
    antispam/spamheaderanalyzer.cpp
    antispam/antispamconfig.cpp
    job/modifymessagedisplayformatjob.cpp
    viewerplugins/viewerpluginmanager.cpp
    viewerplugins/viewerplugin.cpp
    viewerplugins/viewerplugininterface.cpp
    viewerplugins/viewerplugintoolmanager.cpp
    messageviewerconfigureplugins/messageviewerconfiguresettingsplugin.cpp
    messageviewerconfigureplugins/messageviewerconfiguresettingspluginmanager.cpp
    messageviewerconfigureplugins/messageviewerconfiguresettingspluginwidget.cpp
    messageviewercheckbeforedeletingplugins/messageviewercheckbeforedeletingplugin.cpp
    messageviewercheckbeforedeletingplugins/messageviewercheckbeforedeletingpluginmanager.cpp
    messageviewercheckbeforedeletingplugins/messageviewercheckbeforedeletingpluginwidget.cpp
    messageviewercheckbeforedeletingplugins/messageviewercheckbeforedeletinginterface.cpp
    messageviewercheckbeforedeletingplugins/messageviewercheckbeforedeletingparameters.cpp
    messagepartthemes/default/converthtmltoplaintext.cpp
    messagepartthemes/default/defaultrenderer.cpp
    messagepartthemes/default/htmlblock.cpp
    messagepartthemes/default/messagepartrenderermanager.cpp
    messagepartthemes/default/plugins/attachmentmessagepartrenderer.cpp
    messagepartthemes/default/plugins/messagepartrenderer.cpp
    messagepartthemes/default/plugins/textmessagepartrenderer.cpp
    messagepartthemes/default/plugins/quotehtml.cpp
    messagepartthemes/default/messagepartrenderbase.cpp
    messagepartthemes/default/messagepartrenderplugin.cpp
    messagepartthemes/default/messagepartrendererfactory.cpp
    interfaces/htmlwriter.cpp
    remote-content/remotecontentmanager.cpp
    remote-content/remotecontentinfo.cpp
    remote-content/remotecontentmenu.cpp
    remote-content/remotecontentconfiguredialog.cpp
    remote-content/remotecontentconfigurewidget.cpp
    remote-content/remotecontentdialog.cpp
    remote-content/remotecontentwidget.cpp
    remote-content/remotecontentstatustypecombobox.cpp
    settings/messageviewersettings.cpp
    messagepartthemes.qrc
    viewerplugins/viewerplugintoolmanager.h
    viewerplugins/viewerplugininterface.h
    viewerplugins/viewerplugin.h
    viewerplugins/viewerpluginmanager.h
    findbar/findbarsourceview.h
    job/modifymessagedisplayformatjob.h
    htmlwriter/webengineembedpart.h
    htmlwriter/webengineparthtmlwriter.h
    htmlwriter/bufferedhtmlwriter.h
    htmlwriter/filehtmlwriter.h
    utils/markmessagereadhandler.h
    utils/iconnamecache.h
    utils/messageviewerutil_p.h
    utils/messageviewerutil.h
    utils/mimetype.h
    messageviewercheckbeforedeletingplugins/messageviewercheckbeforedeletingpluginwidget.h
    messageviewercheckbeforedeletingplugins/messageviewercheckbeforedeletingparameters.h
    messageviewercheckbeforedeletingplugins/messageviewercheckbeforedeletingplugin.h
    messageviewercheckbeforedeletingplugins/messageviewercheckbeforedeletinginterface.h
    messageviewercheckbeforedeletingplugins/messageviewercheckbeforedeletingpluginmanager.h
    messageviewer_private_export.h
    header/plainheaderstyle.h
    header/contactdisplaymessagememento.h
    header/grantleeheaderstyle.h
    header/headerstyle_util.h
    header/headerstylemenumanager.h
    header/richheaderstrategy.h
    header/grantleeheaderformatter.h
    header/headerstyle.h
    header/headerstyleplugin.h
    header/headerstrategy.h
    header/headerstylepluginmanager.h
    header/kxface.h
    header/headerstyleinterface.h
    messageviewerconfigureplugins/messageviewerconfiguresettingspluginwidget.h
    messageviewerconfigureplugins/messageviewerconfiguresettingsplugin.h
    messageviewerconfigureplugins/messageviewerconfiguresettingspluginmanager.h
    messagepartthemes/default/converthtmltoplaintext.h
    messagepartthemes/default/htmlblock.h
    messagepartthemes/default/defaultrenderer.h
    messagepartthemes/default/messagepartrenderplugin.h
    messagepartthemes/default/messagepartrendererfactory_p.h
    messagepartthemes/default/messagepartrenderermanager.h
    messagepartthemes/default/messagepartrendererfactory.h
    messagepartthemes/default/plugins/textmessagepartrenderer.h
    messagepartthemes/default/plugins/messagepartrenderer.h
    messagepartthemes/default/plugins/quotehtml.h
    messagepartthemes/default/plugins/attachmentmessagepartrenderer.h
    messagepartthemes/default/defaultrenderer_p.h
    messagepartthemes/default/messagepartrendererbase.h
    interfaces/urlhandler.h
    interfaces/bodyparturlhandler.h
    interfaces/htmlwriter.h
    widgets/invitationsettings.h
    widgets/mailsourcewebengineviewer.h
    widgets/mailsourceviewtextbrowserwidget.h
    widgets/shownextmessagewidget.h
    widgets/htmlstatusbar.h
    widgets/printingsettings.h
    widgets/opensavedfilefolderwidget.h
    widgets/configurewidget.h
    widgets/vcardviewer.h
    widgets/attachmentdialog.h
    remote-content/remotecontentinfo.h
    remote-content/remotecontentconfigurewidget.h
    remote-content/remotecontentdialog.h
    remote-content/remotecontentstatustypecombobox.h
    remote-content/remotecontentmanager.h
    remote-content/remotecontentwidget.h
    remote-content/remotecontentmenu.h
    remote-content/remotecontentconfiguredialog.h
    scamdetection/scamcheckshorturlmanager.h
    scamdetection/scamdetectionwebengine.h
    scamdetection/scamdetectioninfo.h
    scamdetection/scamdetectionwarningwidget.h
    scamdetection/scamcheckshorturl.h

=== messageviewer/tests/CMakeLists.txt ===
# SPDX-License-Identifier: CC0-1.0
# SPDX-FileCopyrightText: none
add_executable(viewertest_gui)
target_sources(viewertest_gui PRIVATE
    viewertest_gui.cpp
    ../src/messageviewer_debug.cpp)
target_link_libraries(viewertest_gui
  KF5::Mime
  KF5::MessageViewer
  KF5::GrantleeTheme
  KF5::I18n
  KF5::XmlGui
)

=== mimetreeparser/autotests/CMakeLists.txt ===
# SPDX-License-Identifier: CC0-1.0
# SPDX-FileCopyrightText: none
set(EXECUTABLE_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR})
add_definitions( -DMAIL_DATA_DIR="${CMAKE_CURRENT_SOURCE_DIR}/data" )

include(${CMAKE_SOURCE_DIR}/cmake/modules/kdepim_add_gpg_crypto_test.cmake)

# convenience macro to add qtest unit tests
macro(add_mimetreeparser_unittest _source)
    get_filename_component(_name ${_source} NAME_WE)
    ecm_add_test(${_source} util.cpp setupenv.cpp
        TEST_NAME ${_name}
        NAME_PREFIX "mimetreeparser-"
        LINK_LIBRARIES KF5::MimeTreeParser Qt::Test KF5::Mime Gpgmepp
    )
endmacro ()

macro(add_mimetreeparser_class_unittest _source _additionalSource)
    get_filename_component(_name ${_source} NAME_WE)
    ecm_add_test(${_source} ${_additionalSource}
        TEST_NAME ${_name}
        NAME_PREFIX "mimetreeparser-"
        LINK_LIBRARIES KF5::MimeTreeParser Qt::Test KF5::Mime Gpgmepp
    )
endmacro ()

macro(add_mimetreeparser_crypto_unittest _source)
    set(_test ${_source} util.cpp)
    get_filename_component(_name ${_source} NAME_WE)
    add_executable( ${_name} ${_test} setupenv.cpp)
    ecm_mark_as_test(mimetreeparser-${_name})
    target_link_libraries( ${_name}
        KF5::MimeTreeParser
        Qt::Test
        KF5::Mime
    )
    if (QT_MAJOR_VERSION STREQUAL "6")
        target_link_libraries(${_name} QGpgmeQt6 Qt6::Core5Compat)
    else()
        target_link_libraries(${_name} QGpgme)
    endif()
    add_gpg_crypto_test(${_name} mimetreeparser-${_name})
endmacro ()

add_mimetreeparser_crypto_unittest(attachmenttest.cpp)
add_mimetreeparser_crypto_unittest(basicobjecttreeparsertest.cpp)
add_mimetreeparser_crypto_unittest(protectedheaderstest.cpp)
add_mimetreeparser_unittest(bodypartformatterbasefactorytest.cpp)
add_mimetreeparser_unittest(nodehelpertest.cpp)
add_mimetreeparser_class_unittest(cryptohelpertest.cpp "../src/cryptohelper.cpp")

=== templateparser/src/CMakeLists.txt ===
# SPDX-License-Identifier: CC0-1.0
# SPDX-FileCopyrightText: none

add_definitions(-DTRANSLATION_DOMAIN=\"libtemplateparser\")
add_library(KF5TemplateParser)
add_library(KF5::TemplateParser ALIAS KF5TemplateParser)


target_sources(KF5TemplateParser PRIVATE
    templateparserjob.cpp
    defaulttemplates.cpp
    templatesutil.cpp
    customtemplates.cpp
    customtemplatesmenu.cpp
    templatesconfiguration.cpp
    templatesinsertcommandpushbutton.cpp
    templatescommandmenu.cpp
    templatesinsertcommandaction.cpp
    templatestextedit.cpp
    templatestexteditor.cpp
    templateextracttextfrommail.cpp
    templatewebenginepage.cpp
    templateextracthtmlelementfrommail.cpp
    templateparserextracthtmlinfo.cpp
    templateparserextracthtmlinforesult.cpp
    templateparseremailaddressrequesterbase.cpp
    templateparseremailaddressrequesterlineedit.cpp
    templateparseremailaddressrequesterinterfacewidget.cpp
    templateconvertcommandjob.cpp

    templateextracttextfrommail.h
    templateparserjob.h
    templatestexteditor.h
    templateparseremailaddressrequesterbase.h
    templateparserextracthtmlinforesult.h
    templatescommandmenu.h
    templateparserjob_p.h
    templatestextedit.h
    templateparser_private_export.h
    templatesutil_p.h
    templatesconfiguration.h
    customtemplates.h
    templatewebenginepage.h
    templatesutil.h
    templateparseremailaddressrequesterinterfacewidget.h
    templateparserextracthtmlinfo.h
    defaulttemplates.h
    templatesinsertcommandpushbutton.h
    customtemplatesmenu.h
    templateconvertcommandjob.h
    templatesinsertcommandaction.h
    templateextracthtmlelementfrommail.h
    templateparseremailaddressrequesterlineedit.h
    )
ecm_qt_declare_logging_category(KF5TemplateParser HEADER templateparser_debug.h IDENTIFIER TEMPLATEPARSER_LOG CATEGORY_NAME org.kde.pim.templateparser
        DESCRIPTION "messagelib (templateparser)"
        OLD_CATEGORY_NAMES log_templateparser
        EXPORT MESSAGELIB
    )



kconfig_add_kcfg_files(KF5TemplateParser settings/templatesconfiguration_kfg.kcfgc)

kconfig_add_kcfg_files(KF5TemplateParser
    settings/customtemplates_kfg.kcfgc
    settings/globalsettings_templateparser.kcfgc
    )

ki18n_wrap_ui(KF5TemplateParser
    ui/templatesconfiguration_base.ui
    ui/customtemplates_base.ui
    )

if (COMPILE_WITH_UNITY_CMAKE_SUPPORT)
    set_target_properties(KF5TemplateParser PROPERTIES UNITY_BUILD ON)
endif()

generate_export_header(KF5TemplateParser BASE_NAME templateparser)

target_link_libraries(KF5TemplateParser
    PRIVATE
    KF5::Mime
    KF5::MimeTreeParser
    KF5::IdentityManagement
    KF5::MessageCore
    KF5::XmlGui
    KF5::Completion
    KF5::CoreAddons
    KF5::I18n
    KF5::SonnetUi
    KF5::SyntaxHighlighting
    Qt::WebEngineWidgets
    KF5::Libkdepim
    KF5::PimTextEdit
    )
set_target_properties(KF5TemplateParser PROPERTIES
    VERSION ${TEMPLATEPARSER_VERSION}
    SOVERSION ${TEMPLATEPARSER_SOVERSION}
    EXPORT_NAME TemplateParser
    )

target_include_directories(KF5TemplateParser INTERFACE "$<INSTALL_INTERFACE:${KDE_INSTALL_INCLUDEDIR_KF}/TemplateParser/>")

install(FILES
    settings/customtemplates_kfg.kcfg
    settings/templatesconfiguration_kfg.kcfg
    DESTINATION ${KDE_INSTALL_KCFGDIR}
    )

ecm_generate_headers(TemplateParser_CamelCase_HEADERS
    HEADER_NAMES
    CustomTemplates
    CustomTemplatesMenu
    DefaultTemplates
    TemplatesConfiguration
    TemplatesTextEdit
    TemplatesUtil
    TemplatesInsertCommandPushButton
    TemplatesCommandMenu
    TemplatesInsertCommandAction
    TemplateParserJob
    TemplateParserExtractHtmlInfoResult
    TemplateParserEmailAddressRequesterBase
    TemplateConvertCommandJob
    REQUIRED_HEADERS TemplateParser_HEADERS
    PREFIX TemplateParser
    )

ecm_generate_pri_file(BASE_NAME TemplateParser
    LIB_NAME KF5TemplateParser
    DEPS "" FILENAME_VAR PRI_FILENAME INCLUDE_INSTALL_DIR ${KDE_INSTALL_INCLUDEDIR_KF}/TemplateParser
    )


install(TARGETS KF5TemplateParser EXPORT KF5TemplateParserTargets ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})



install(FILES
    ${TemplateParser_CamelCase_HEADERS}
    DESTINATION ${KDE_INSTALL_INCLUDEDIR_KF}/TemplateParser/TemplateParser
    COMPONENT Devel
    )

install(FILES
    ${TemplateParser_HEADERS}
    ${CMAKE_CURRENT_BINARY_DIR}/templateparser_export.h
    ${CMAKE_CURRENT_BINARY_DIR}/globalsettings_templateparser.h
    ${CMAKE_CURRENT_BINARY_DIR}/customtemplates_kfg.h
    ${CMAKE_CURRENT_BINARY_DIR}/ui_templatesconfiguration_base.h
    ${CMAKE_CURRENT_BINARY_DIR}/templatesconfiguration_kfg.h
    DESTINATION ${KDE_INSTALL_INCLUDEDIR_KF}/TemplateParser/templateparser
    COMPONENT Devel
    )

install(FILES
    ${PRI_FILENAME}
    DESTINATION ${ECM_MKSPECS_INSTALL_DIR})

install(FILES syntax/kmail-template.xml DESTINATION ${KDE_INSTALL_DATADIR}/org.kde.syntax-highlighting/syntax)

if (BUILD_QCH)
    ecm_add_qch(
        KF5TemplateParser_QCH
        NAME KF5TemplateParser
        BASE_NAME KF5TemplateParser
        VERSION ${PIM_VERSION}
        ORG_DOMAIN org.kde
        SOURCES # using only public headers, to cover only public API
        ${TemplateParser_HEADERS}
        LINK_QCHS
            Qt5Core_QCH
            Qt5Gui_QCH
            Qt5Widgets_QCH
        INCLUDE_DIRS
            ${CMAKE_CURRENT_BINARY_DIR}
        BLANK_MACROS
            TEMPLATEPARSER_EXPORT
        TAGFILE_INSTALL_DESTINATION ${KDE_INSTALL_QTQCHDIR}
        QCH_INSTALL_DESTINATION ${KDE_INSTALL_QTQCHDIR}
        COMPONENT Devel
    )

    ecm_install_qch_export(
        TARGETS KF5TemplateParser_QCH
        FILE KF5TemplateParserQchTargets.cmake
        DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
        COMPONENT Devel
    )
    set(PACKAGE_INCLUDE_QCHTARGETS "include(\"\${CMAKE_CURRENT_LIST_DIR}/KF5TemplateParserQchTargets.cmake\")")
endif()

=== messagecomposer/src/composer-ng/autotests/CMakeLists.txt ===
# SPDX-License-Identifier: CC0-1.0
# SPDX-FileCopyrightText: none
add_definitions( -DSIGNATURE_DATA_DIR="${CMAKE_CURRENT_SOURCE_DIR}/data" )

macro(add_composerng_autocorrect_unittest _source)
    ecm_add_test(${_source}
        NAME_PREFIX "messagecomposer-composerng-"
        LINK_LIBRARIES Qt::Test KF5::MessageComposer KF5::XmlGui
    )
endmacro()

add_composerng_autocorrect_unittest(richtextcomposerngtest.cpp)
add_composerng_autocorrect_unittest(richtextcomposersignaturestest.cpp)

=== messagecomposer/src/composer/autotests/CMakeLists.txt ===
# SPDX-License-Identifier: CC0-1.0
# SPDX-FileCopyrightText: none
macro(add_composer_unittest _source)
    ecm_add_test(${_source}
        NAME_PREFIX "messagecomposer-composer-"
        LINK_LIBRARIES Qt::Test KF5::MessageComposer
    )
endmacro()

add_composer_unittest(composerattachmentinterfacetest.cpp)

=== messagecomposer/src/imagescaling/tests/CMakeLists.txt ===
# SPDX-License-Identifier: CC0-1.0
# SPDX-FileCopyrightText: none
add_executable(imagescaling_gui imagescaling_gui.cpp)
target_link_libraries(imagescaling_gui
  KF5::KIOCore
  KF5::MessageComposer
  KF5::I18n
)

=== messagecomposer/src/snippet/autotests/CMakeLists.txt ===
# SPDX-License-Identifier: CC0-1.0
# SPDX-FileCopyrightText: none
macro(add_composer_snippet_unittest _source)
    ecm_add_test(${_source}
        NAME_PREFIX "messagecomposer-snippet-"
        LINK_LIBRARIES Qt::Test KF5::MessageComposer KF5::Completion
    )
endmacro()

add_composer_snippet_unittest(convertvariablesjobtest.cpp)
add_composer_snippet_unittest(convertsnippetvariablesutiltest.cpp)
add_composer_snippet_unittest(convertsnippetvariablemenutest.cpp)

=== debian/changelog ===
kf5-messagelib (4:22.12.3-2~deb12u1) bookworm; urgency=medium

  * Rebuilt for bookworm.

 -- Sandro Knauß <hefee@debian.org>  Sun, 02 Jul 2023 23:21:13 +0200

kf5-messagelib (4:22.12.3-2) unstable; urgency=medium

  * Add upstream patch to search also for subkeys (Closes: #1037363).

 -- Sandro Knauß <hefee@debian.org>  Tue, 27 Jun 2023 14:09:30 +0200

kf5-messagelib (4:22.12.3-1) unstable; urgency=medium

  [ Patrick Franz ]
  * New upstream release (22.12.3).
  * Update build-deps and deps with the info from cmake.
  * Remove inactive uploaders, thanks for your work.

 -- Patrick Franz <deltaone@debian.org>  Wed, 01 Mar 2023 21:33:30 +0100

kf5-messagelib (4:22.12.2-1) unstable; urgency=medium

  [ Patrick Franz ]
  * New upstream release (22.12.2).
  * Update build-deps and deps with the info from cmake.

 -- Patrick Franz <deltaone@debian.org>  Sun, 05 Feb 2023 00:27:57 +0100

=== debian/control ===
Source: kf5-messagelib
Section: libs
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Sandro Knauß <hefee@debian.org>,
           Patrick Franz <deltaone@debian.org>,
Build-Depends: cmake (>= 3.16~),
               debhelper-compat (= 13),
               extra-cmake-modules (>= 5.99.0~),
               git,
               libgpgmepp-dev (>= 1.15.0~) | libgpgme7-dev,
               libgrantlee5-dev (>= 5.2~),
               libkf5akonadi-dev (>= 4:22.12.3~),
               libkf5akonadicontact-dev (>= 4:22.12.3~),
               libkf5akonadimime-dev (>= 4:22.12.3~),
               libkf5akonadisearch-dev (>= 4:22.12.3~),
               libkf5archive-dev (>= 5.99.0~),
               libkf5codecs-dev (>= 5.99.0~),
               libkf5completion-dev (>= 5.99.0~),
               libkf5config-dev (>= 5.99.0~),
               libkf5configwidgets-dev (>= 5.99.0~),
               libkf5contacts-dev (>= 5:5.99.0~),
               libkf5coreaddons-dev (>= 5.99.0~),
               libkf5dbusaddons-dev (>= 5.99.0~),
               libkf5grantleetheme-dev (>= 22.12.3~),
               libkf5gravatar-dev (>= 4:22.12.3~),
               libkf5guiaddons-dev (>= 5.99.0~),
               libkf5i18n-dev (>= 5.99.0~),
               libkf5iconthemes-dev (>= 5.99.0~),
               libkf5identitymanagement-dev (>= 22.12.3~),
               libkf5itemviews-dev (>= 5.99.0~),
               libkf5jobwidgets-dev (>= 5.99.0~),
               libkf5kio-dev (>= 5.99.0~),
               libkf5libkdepim-dev (>= 4:22.12.3~),
               libkf5libkleo-dev (>= 4:22.12.3~),
               libkf5mailtransport-dev (>= 22.12.3~),
               libkf5mbox-dev (>= 22.12.3~),
               libkf5mime-dev (>= 22.12.3~),
               libkf5newstuff-dev (>= 5.99.0~),
               libkf5notifications-dev (>= 5.99.0~),
               libkf5pimcommon-dev (>= 4:22.12.3~),
               libkf5pimtextedit-dev (>= 22.12.3~),
               libkf5service-dev (>= 5.99.0~),
               libkf5sonnet-dev (>= 5.99.0~),
               libkf5syntaxhighlighting-dev (>= 5.99.0~),
               libkf5textwidgets-dev (>= 5.99.0~),
               libkf5widgetsaddons-dev (>= 5.99.0~),
               libkf5xmlgui-dev (>= 5.99.0~),
               libqca-qt5-2-dev (>= 2.3.0~),
               libxml2-utils,
               pkg-kde-tools (>= 0.15.31),
               qtbase5-dev (>= 5.15.2~),
               qtwebengine5-dev (>= 5.15.2~),
               xauth,
               xvfb,
Standards-Version: 4.6.2
Homepage: https://invent.kde.org/pim/messagelib
Vcs-Browser: https://salsa.debian.org/qt-kde-team/kde/messagelib
Vcs-Git: https://salsa.debian.org/qt-kde-team/kde/messagelib.git
Rules-Requires-Root: no

Package: kf5-messagelib-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
Description: KDE PIM messaging library, data files
 This package contains the data files shipped with the message libraries.
 .
 This package is part of KDE PIM module.

Package: libkf5messagecomposer-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libkf5identitymanagement-dev (>= 22.12.3~),
         libkf5libkleo-dev (>= 4:22.12.3~),
         libkf5messagecomposer5abi1 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: KDE PIM messaging library, composer devel files
 This package contains the development files for the message composer library.
 Which provides basic e-mail message composing facilities.
 .
 This package is part of KDE PIM module.

Package: libkf5messagecomposer5abi1
X-Debian-ABI: 1
X-CMake-Target: KF5MessageComposer
Architecture: any
Multi-Arch: same
Depends: kf5-messagelib-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: KDE PIM messaging library, composer library
 This package contains the message composer library. It provides basic e-mail
 message composing facilities.
 .
 This package is part of KDE PIM module.
Provides: ${ABI:VirtualPackage},

Package: libkf5messagecore-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libkf5messagecore5abi1 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: KDE PIM messaging library, core devel files
 This package contains the development files for the message core library.
 Which provides basic e-mail message handling facilities.
 .
 This package is part of KDE PIM module.

Package: libkf5messagecore5abi1
X-Debian-ABI: 1
X-CMake-Target: KF5MessageCore
Architecture: any
Multi-Arch: same
Depends: kf5-messagelib-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: KDE PIM messaging library, core library
 This package contains the message core library. It provides basic e-mail
 message handling facilities.
 .
 This package is part the KDE PIM module.
Provides: ${ABI:VirtualPackage},

Package: libkf5messagelist-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libkf5akonadi-dev (>= 4:22.12.3~),
         libkf5messagelist5abi1 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: KDE PIM messaging library, message list devel files
 This package contains the development files for the message list library.
 Which provides a widget for the e-mail message lists with extensive filtering,
 grouping and useful features.
 .
 This package is part of KDE PIM module.

Package: libkf5messagelist5abi1
X-Debian-ABI: 1
X-CMake-Target: KF5MessageList
Architecture: any
Multi-Arch: same
Depends: kf5-messagelib-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: KDE PIM messaging library, message list library
 This package contains the message list library. It provides a widget for the
 e-mail message lists with extensive filtering, grouping and useful features.
 .
 This package is part of the KDE PIM module.
Provides: ${ABI:VirtualPackage},

Package: libkf5messageviewer-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libkf5messagecore-dev (= ${binary:Version}),
         libkf5messageviewer5abi1 (= ${binary:Version}),
         libkf5mimetreeparser-dev (= ${binary:Version}),
         libkf5pimcommon-dev (>= 4:22.12.3~),
         ${misc:Depends},
         ${shlibs:Depends},
Description: KDE PIM messaging library, message viewer devel files
 This package contains the development files for the message viewer library.
 Which provides the implementation of a feature-rich and highly configurable
 widget for viewing e-mail messages.
 .
 This package is part of KDE PIM module.

Package: libkf5messageviewer5abi1
X-Debian-ABI: 1
X-CMake-Target: KF5MessageViewer
Architecture: any
Multi-Arch: same
Depends: kf5-messagelib-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: KDE PIM messaging library, message viewer library
 This package contains the message viewer library which implements feature-rich
 and highly configurable widget for viewing e-mail messages.
 .
 This package is part of the KDE PIM module.
Provides: ${ABI:VirtualPackage},

Package: libkf5mimetreeparser-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libkf5mime-dev (>= 22.12.3~),
         libkf5mimetreeparser5abi1 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: KDE PIM Mime Tree parser library - devel files
 This library implements a parser for the mime tree used by KMail.
 .
 This package is part of the KDE PIM module.

Package: libkf5mimetreeparser5abi1
X-Debian-ABI: 1
X-CMake-Target: KF5MimeTreeParser
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: KDE PIM Mime Tree parser library
 This library implements a parser for the mime tree used by KMail.
 .
 This package is part of the KDE PIM module.
 This package contains the development files for the mime tree parser library.
Provides: ${ABI:VirtualPackage},

Package: libkf5templateparser-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libkf5templateparser5 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: KDE PIM messaging library, template parser devel files
 This package contains the development files for the template parser library.
 Which provides the implementation of a parser for the mail templates which
 KMail uses to enable customization of initial structure for the new, reply or
 forwarded messages.
 .
 This package is part of KDE PIM module.

Package: libkf5templateparser5
Architecture: any
Multi-Arch: same
Depends: kf5-messagelib-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: KMail template parser library
 This library implements a parser for the mail templates which KMail uses to
 enable customization of initial structure for the new, reply or forwarded
 messages.
 .
 This package is part of the KDE PIM module.
Provides: ${ABI:VirtualPackage},

Package: libkf5webengineviewer-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libkf5webengineviewer5abi1 (= ${binary:Version}),
         qtwebengine5-dev (>= 5.15.2~),
         ${misc:Depends},
         ${shlibs:Depends},
Description: KDE's Qt Web Engine Viewer - devel files
 This library implements view on Qt Web Engine used by KDE PIM.
 .
 This package is part of the KDE PIM module.
 This package contains the development files for the Qt Web Engine Viewer.

Package: libkf5webengineviewer5abi1
X-Debian-ABI: 1
X-CMake-Target: KF5WebEngineViewer
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends},
Multi-Arch: same
Description: KDE's Qt Web Engine Viewer
 This library implements view on Qt Web Engine used by KDE PIM.
 .
 This package is part of the KDE PIM module.
Provides: ${ABI:VirtualPackage},

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/default.mk
libpkgs_gen_strict_local_shlibs = $(libpkgs_all_packages)
include /usr/share/pkg-kde-tools/qt-kde-team/3/library-packages.mk

AbiVirtualPackageVersion = $(call dpkg_late_eval,AbiVirtualPackageVersion,echo '${DEB_VERSION_UPSTREAM}' | sed -e 's/\.[0-9]\+$$//')
pkgs_lib = $(filter-out %-dev %-doc %-dbg %-data %-bin %-plugins,$(filter lib%,$(shell dh_listpackages)))

%:
	dh $@ --with kf5

override_dh_makeshlibs:
	for pkg in $(pkgs_lib); do \
		name=$$( echo "$${pkg}" | sed -e 's/abi[0-9]\+\s*//'); \
		echo "ABI:VirtualPackage=$${name}-${AbiVirtualPackageVersion}" >> debian/$${pkg}.substvars; \
		dh_makeshlibs -p$${pkg} -V "$${pkg} (>= $(DEB_VERSION_EPOCH_UPSTREAM)), $${name}-${AbiVirtualPackageVersion}"; \
	done

override_dh_auto_test:
# The tests do not run successfully on mipsel for buster and it seems,
# that it is a RAM issue as the tests are anyways flaky,
# disable the tests for now. (hefee - 20190301)
ifeq ($(DEB_HOST_ARCH), mipsel)
	echo "tests disabled for mipsel"
else
	- xvfb-run -a --server-args="-screen 0 1024x768x24 +extension GLX" --\
	           dh_auto_test --no-parallel
endif

override_dh_gencontrol-arch: libpkgs_gen_strict_local_shlibs
	dh_gencontrol -a
